Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Tests/HeuristicLab.Clients.Hive.Slave.Tests-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Tests/HeuristicLab.Clients.Hive.Slave.Tests-3.4.csproj	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Tests/HeuristicLab.Clients.Hive.Slave.Tests-3.4.csproj	(revision 5402)
@@ -33,4 +33,36 @@
     <WarningLevel>4</WarningLevel>
   </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\HeuristicLab.Clients.Hive.Slave.Tests-3.4.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\HeuristicLab.Clients.Hive.Slave.Tests-3.4.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
   <ItemGroup>
     <Reference Include="ALGLIB-2.5.0">
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLab.Clients.Hive.Slave.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLab.Clients.Hive.Slave.Views-3.4.csproj	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.Views/3.4/HeuristicLab.Clients.Hive.Slave.Views-3.4.csproj	(revision 5402)
@@ -37,4 +37,36 @@
   <PropertyGroup>
     <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\HeuristicLab.Clients.Hive.Slave.Views-3.4.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\HeuristicLab.Clients.Hive.Slave.Views-3.4.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
   </PropertyGroup>
   <ItemGroup>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs	(revision 5402)
@@ -40,5 +40,5 @@
 
     //TODO: this class should be a singleton; there is only one instance, the reference is meanwhile save in TheCore
-    public static Core TheCore;
+    public static Core theCore;
 
     public static bool abortRequested { get; set; }
@@ -66,5 +66,5 @@
 
     public Core() {
-      TheCore = this;
+      theCore = this;
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/HeuristicLab.Clients.Hive.Slave-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/HeuristicLab.Clients.Hive.Slave-3.4.csproj	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/HeuristicLab.Clients.Hive.Slave-3.4.csproj	(revision 5402)
@@ -37,4 +37,36 @@
   <PropertyGroup>
     <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\HeuristicLab.Clients.Hive.Slave-3.4.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>true</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>true</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\HeuristicLab.Clients.Hive.Slave-3.4.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>true</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>true</CodeAnalysisIgnoreBuiltInRules>
   </PropertyGroup>
   <ItemGroup>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/SlaveCommunicationService.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/SlaveCommunicationService.cs	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/SlaveCommunicationService.cs	(revision 5402)
@@ -84,16 +84,16 @@
 
     public void Restart() {
-      Core.TheCore.Restart();
+      Core.theCore.Restart();
     }
     public void HardPause() {
-      Core.TheCore.HardPause();
+      Core.theCore.HardPause();
     }
 
     public void SoftPause() {
-      Core.TheCore.SoftPause();
+      Core.theCore.SoftPause();
     }
 
     public void ShutdownSlave() {
-      Core.TheCore.Shutdown();
+      Core.theCore.Shutdown();
     }
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentView.Designer.cs	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentView.Designer.cs	(revision 5402)
@@ -53,5 +53,4 @@
       this.viewExperimentButton = new System.Windows.Forms.Button();
       this.jobsTabPage = new System.Windows.Forms.TabPage();
-      this.hiveJobView = new HiveJobView();
       this.logTabPage = new System.Windows.Forms.TabPage();
       this.logView = new HeuristicLab.Core.Views.LogView();
@@ -68,4 +67,6 @@
       this.reconnectButton = new System.Windows.Forms.Button();
       this.downloadExperimentPanel = new System.Windows.Forms.Panel();
+      this.useLocalPluginsCheckBox = new System.Windows.Forms.CheckBox();
+      this.hiveJobView = new HeuristicLab.Clients.Hive.Views.HiveJobView();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tabControl.SuspendLayout();
@@ -80,9 +81,9 @@
       this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
       this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      this.nameTextBox.Size = new System.Drawing.Size(663, 20);
+      this.nameTextBox.Size = new System.Drawing.Size(670, 20);
       // 
       // descriptionTextBox
       // 
-      this.descriptionTextBox.Size = new System.Drawing.Size(663, 20);
+      this.descriptionTextBox.Size = new System.Drawing.Size(670, 20);
       // 
       // tabControl
@@ -97,5 +98,5 @@
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(735, 416);
+      this.tabControl.Size = new System.Drawing.Size(742, 416);
       this.tabControl.TabIndex = 4;
       // 
@@ -109,5 +110,5 @@
       this.experimentTabPage.Name = "experimentTabPage";
       this.experimentTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.experimentTabPage.Size = new System.Drawing.Size(727, 390);
+      this.experimentTabPage.Size = new System.Drawing.Size(734, 390);
       this.experimentTabPage.TabIndex = 1;
       this.experimentTabPage.Text = "Experiment";
@@ -145,5 +146,5 @@
       this.experimentNamedItemView.Name = "experimentNamedItemView";
       this.experimentNamedItemView.ReadOnly = false;
-      this.experimentNamedItemView.Size = new System.Drawing.Size(721, 52);
+      this.experimentNamedItemView.Size = new System.Drawing.Size(728, 52);
       this.experimentNamedItemView.TabIndex = 3;
       // 
@@ -154,5 +155,5 @@
       this.viewExperimentButton.Location = new System.Drawing.Point(0, 94);
       this.viewExperimentButton.Name = "viewExperimentButton";
-      this.viewExperimentButton.Size = new System.Drawing.Size(727, 23);
+      this.viewExperimentButton.Size = new System.Drawing.Size(734, 23);
       this.viewExperimentButton.TabIndex = 1;
       this.viewExperimentButton.Text = "&Show Experiment";
@@ -165,22 +166,9 @@
       this.jobsTabPage.Location = new System.Drawing.Point(4, 22);
       this.jobsTabPage.Name = "jobsTabPage";
-      this.jobsTabPage.Size = new System.Drawing.Size(727, 390);
+      this.jobsTabPage.Size = new System.Drawing.Size(734, 390);
       this.jobsTabPage.TabIndex = 5;
       this.jobsTabPage.Text = "Jobs";
       this.jobsTabPage.UseVisualStyleBackColor = true;
       // 
-      // hiveJobView
-      // 
-      this.hiveJobView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.hiveJobView.Caption = "HiveJob View";
-      this.hiveJobView.Content = null;
-      this.hiveJobView.Location = new System.Drawing.Point(2, 3);
-      this.hiveJobView.Name = "hiveJobView";
-      this.hiveJobView.ReadOnly = true;
-      this.hiveJobView.Size = new System.Drawing.Size(722, 384);
-      this.hiveJobView.TabIndex = 0;
-      // 
       // logTabPage
       // 
@@ -188,5 +176,5 @@
       this.logTabPage.Location = new System.Drawing.Point(4, 22);
       this.logTabPage.Name = "logTabPage";
-      this.logTabPage.Size = new System.Drawing.Size(727, 390);
+      this.logTabPage.Size = new System.Drawing.Size(734, 390);
       this.logTabPage.TabIndex = 3;
       this.logTabPage.Text = "Log";
@@ -262,5 +250,5 @@
       this.executionTimeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.executionTimeLabel.AutoSize = true;
-      this.executionTimeLabel.Location = new System.Drawing.Point(509, 507);
+      this.executionTimeLabel.Location = new System.Drawing.Point(516, 507);
       this.executionTimeLabel.Name = "executionTimeLabel";
       this.executionTimeLabel.Size = new System.Drawing.Size(83, 13);
@@ -271,5 +259,5 @@
       // 
       this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.executionTimeTextBox.Location = new System.Drawing.Point(598, 504);
+      this.executionTimeTextBox.Location = new System.Drawing.Point(605, 504);
       this.executionTimeTextBox.Name = "executionTimeTextBox";
       this.executionTimeTextBox.ReadOnly = true;
@@ -305,5 +293,5 @@
       this.resourceIdsTextBox.Location = new System.Drawing.Point(72, 52);
       this.resourceIdsTextBox.Name = "resourceIdsTextBox";
-      this.resourceIdsTextBox.Size = new System.Drawing.Size(663, 20);
+      this.resourceIdsTextBox.Size = new System.Drawing.Size(559, 20);
       this.resourceIdsTextBox.TabIndex = 14;
       this.resourceIdsTextBox.Validated += new System.EventHandler(this.resourceIdsTextBox_Validated);
@@ -343,4 +331,29 @@
       this.downloadExperimentPanel.TabIndex = 18;
       // 
+      // useLocalPluginsCheckBox
+      // 
+      this.useLocalPluginsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.useLocalPluginsCheckBox.AutoSize = true;
+      this.useLocalPluginsCheckBox.Location = new System.Drawing.Point(637, 54);
+      this.useLocalPluginsCheckBox.Name = "useLocalPluginsCheckBox";
+      this.useLocalPluginsCheckBox.Size = new System.Drawing.Size(105, 17);
+      this.useLocalPluginsCheckBox.TabIndex = 19;
+      this.useLocalPluginsCheckBox.Text = "UseLocalPlugins";
+      this.useLocalPluginsCheckBox.UseVisualStyleBackColor = true;
+      this.useLocalPluginsCheckBox.CheckedChanged += new System.EventHandler(this.useLocalPluginsCheckBox_CheckedChanged);
+      // 
+      // hiveJobView
+      // 
+      this.hiveJobView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.hiveJobView.Caption = "HiveJob View";
+      this.hiveJobView.Content = null;
+      this.hiveJobView.Location = new System.Drawing.Point(2, 3);
+      this.hiveJobView.Name = "hiveJobView";
+      this.hiveJobView.ReadOnly = true;
+      this.hiveJobView.Size = new System.Drawing.Size(722, 384);
+      this.hiveJobView.TabIndex = 0;
+      // 
       // HiveExperimentView
       // 
@@ -355,4 +368,5 @@
       this.Controls.Add(this.resourceIdsLabel);
       this.Controls.Add(this.executionTimeLabel);
+      this.Controls.Add(this.useLocalPluginsCheckBox);
       this.Controls.Add(this.pauseButton);
       this.Controls.Add(this.stopButton);
@@ -360,9 +374,12 @@
       this.Controls.Add(this.reconnectButton);
       this.Name = "HiveExperimentView";
-      this.Size = new System.Drawing.Size(735, 524);
+      this.Size = new System.Drawing.Size(742, 524);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.descriptionTextBox, 0);
       this.Controls.SetChildIndex(this.reconnectButton, 0);
       this.Controls.SetChildIndex(this.resetButton, 0);
       this.Controls.SetChildIndex(this.stopButton, 0);
       this.Controls.SetChildIndex(this.pauseButton, 0);
+      this.Controls.SetChildIndex(this.useLocalPluginsCheckBox, 0);
       this.Controls.SetChildIndex(this.executionTimeLabel, 0);
       this.Controls.SetChildIndex(this.resourceIdsLabel, 0);
@@ -374,6 +391,4 @@
       this.Controls.SetChildIndex(this.nameLabel, 0);
       this.Controls.SetChildIndex(this.descriptionLabel, 0);
-      this.Controls.SetChildIndex(this.nameTextBox, 0);
-      this.Controls.SetChildIndex(this.descriptionTextBox, 0);
       this.Controls.SetChildIndex(this.downloadExperimentPanel, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
@@ -411,4 +426,5 @@
     private System.Windows.Forms.Panel downloadExperimentPanel;
     private HiveJobView hiveJobView;
+    private System.Windows.Forms.CheckBox useLocalPluginsCheckBox;
 
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentView.cs	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/HiveExperimentView.cs	(revision 5402)
@@ -84,8 +84,10 @@
         executionTimeTextBox.Text = string.Empty;
         resourceIdsTextBox.Text = string.Empty;
+        useLocalPluginsCheckBox.Checked = false;
         logView.Content = null;
       } else {
         executionTimeTextBox.Text = Content.ExecutionTime.ToString();
         resourceIdsTextBox.Text = Content.ResourceIds;
+        useLocalPluginsCheckBox.Checked = Content.UseLocalPlugins;
         logView.Content = Content.Log;
       }
@@ -104,4 +106,5 @@
         this.resourceIdsTextBox.ReadOnly = Content.ExecutionState != ExecutionState.Prepared;
         this.hiveJobView.ReadOnly = Content.ExecutionState != ExecutionState.Prepared;
+        this.useLocalPluginsCheckBox.Enabled = Content.ExecutionState == ExecutionState.Prepared;
 
         viewExperimentButton.Enabled = Content.GetExperiment() != null;
@@ -247,4 +250,10 @@
         Content.StartResultPolling();
         SetEnabledStateOfControls();
+      }
+    }
+
+    private void useLocalPluginsCheckBox_CheckedChanged(object sender, EventArgs e) {
+      if (Content != null) {
+        Content.UseLocalPlugins = useLocalPluginsCheckBox.Checked;
       }
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/MenuItems/ExperimentManagerMenuItem.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/MenuItems/ExperimentManagerMenuItem.cs	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/ExperimentManager/MenuItems/ExperimentManagerMenuItem.cs	(revision 5402)
@@ -28,5 +28,5 @@
   public class ExperimentManagerMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
     public override string Name {
-      get { return "&Experiment Manager"; }
+      get { return "&Experiment Manager 3.4"; }
     }
     public override IEnumerable<string> Structure {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj	(revision 5402)
@@ -38,4 +38,36 @@
     <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
   </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\HeuristicLab.Clients.Hive.Views-3.4.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\HeuristicLab.Clients.Hive.Views-3.4.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
   <ItemGroup>
     <Reference Include="HeuristicLab.Collections-3.3">
@@ -86,10 +118,4 @@
   <ItemGroup>
     <None Include="HeuristicLabClientsHiveViewsPlugin.cs.frame" />
-    <Compile Include="ExperimentManager\ConnectionSetupView.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="ExperimentManager\ConnectionSetupView.Designer.cs">
-      <DependentUpon>ConnectionSetupView.cs</DependentUpon>
-    </Compile>
     <Compile Include="ExperimentManager\HiveExperimentListView.cs">
       <SubType>UserControl</SubType>
@@ -122,5 +148,4 @@
       <DependentUpon>HiveJobView.cs</DependentUpon>
     </Compile>
-    <Compile Include="ExperimentManager\MenuItems\ConnectionSetupMenuItem.cs" />
     <Compile Include="ExperimentManager\MenuItems\ExperimentManagerMenuItem.cs" />
     <Compile Include="HeuristicLabClientsHiveViewsPlugin.cs" />
@@ -138,7 +163,4 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="ExperimentManager\ConnectionSetupView.resx">
-      <DependentUpon>ConnectionSetupView.cs</DependentUpon>
-    </EmbeddedResource>
     <EmbeddedResource Include="ExperimentManager\HiveExperimentManagerView.resx">
       <DependentUpon>HiveExperimentManagerView.cs</DependentUpon>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentClient.cs	(revision 5375)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentClient.cs	(revision 5402)
@@ -29,10 +29,13 @@
 using HeuristicLab.Services.Hive.Common;
 using HeuristicLab.Services.Hive.Common.ServiceContracts;
+using HeuristicLab.Services.Hive.Common.DataTransfer;
+using HeuristicLab.Clients.Hive.Jobs;
+using HeuristicLab.Clients.Common;
+using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Clients.Hive {
   using DT = HeuristicLab.Services.Hive.Common.DataTransfer;
-  using HeuristicLab.Services.Hive.Common.DataTransfer;
-  using HeuristicLab.Clients.Hive.Jobs;
-  using HeuristicLab.Clients.Common;
+  using HeuristicLab.PluginInfrastructure;
+  using System.IO;
 
   /// <summary>
@@ -111,7 +114,19 @@
     }
 
+    private List<Guid> pluginsNeededIds;
+    public List<Guid> PluginsNeededIds {
+      get { return pluginsNeededIds; }
+      set { pluginsNeededIds = value; } 
+    }
+
+    private bool useLocalPlugins;
+    public bool UseLocalPlugins {
+      get { return useLocalPlugins; }
+      set { useLocalPlugins = value; }
+    }
+    
     public HiveExperimentClient() : base(itemName, itemDescription) {
       // TODO //this.ResourceIds = HeuristicLab.Hive.Experiment.Properties.Settings.Default.ResourceIds;
-      this.ResourceIds = "MyGroup";
+      this.ResourceIds = "HEAL";
       this.log = new Log();
       InitTimer();
@@ -151,5 +166,5 @@
     }
 
-    public void SetExperiment(Optimization.Experiment experiment) {
+    public void SetExperiment(Experiment experiment) {
       this.HiveJob = new HiveJob(experiment);
       Prepare();
@@ -171,5 +186,5 @@
     /// Returns the experiment from the root HiveJob
     /// </summary>
-    public Optimization.Experiment GetExperiment() {
+    public Experiment GetExperiment() {
       if (this.HiveJob != null) {
         return HiveJob.OptimizerJob.OptimizerAsExperiment;
@@ -179,5 +194,5 @@
 
     #region IExecutable Members
-    private Core.ExecutionState executionState;
+    private ExecutionState executionState;
     public ExecutionState ExecutionState {
       get { return executionState; }
@@ -231,4 +246,7 @@
           int jobCount = 0;
 
+          this.progress.Status = "Uploading plugins...";
+          this.PluginsNeededIds = GetPluginsNeededIds(this.useLocalPlugins);
+
           this.progress.Status = "Uploading jobs...";
           UploadJobWithChildren(service.Obj, this.HiveJob, null, groups, ref jobCount, totalJobCount);
@@ -251,4 +269,40 @@
         IsProgressing = false;
       }
+    }
+
+    /// <summary>
+    /// Gets the Ids of all plugins needed for executing the job.
+    /// All loaded plugins are assumed to be necessary.
+    /// If a plugin with the same name and version is already online, it is used. Otherwise the local plugin is uploaded.
+    /// If useLocalPlugins is true, all local plugins are uploaded regardless of the existence of the same plugin online.
+    /// </summary>
+    public static List<Guid> GetPluginsNeededIds(bool useLocalPlugins) {
+      IEnumerable<IPluginDescription> localPlugins = ApplicationManager.Manager.Plugins;
+      List<Guid> pluginsNeededIds = new List<Guid>();
+
+      using (var service = ServiceLocator.Instance.GetService()) {
+        IEnumerable<Plugin> onlinePlugins = service.Obj.GetPlugins();
+
+        foreach (IPluginDescription localPlugin in localPlugins) {
+          Plugin found = onlinePlugins.Where(onlinePlugin => onlinePlugin.Name == localPlugin.Name && onlinePlugin.Version == localPlugin.Version).SingleOrDefault();
+          if (!useLocalPlugins && found != null) {
+            // plugin is available online; reuse
+            pluginsNeededIds.Add(found.Id);
+          } else {
+            // upload the plugin
+            Plugin p = new Plugin() { Name = localPlugin.Name, Version = localPlugin.Version, IsLocal = useLocalPlugins };
+            List<PluginData> pluginDatas = new List<PluginData>();
+
+            foreach (IPluginFile pf in localPlugin.Files) {
+              PluginData pluginData = new PluginData();
+
+              pluginData.Data = File.ReadAllBytes(pf.Name);
+              pluginDatas.Add(pluginData);
+            }
+            pluginsNeededIds.Add(service.Obj.AddPlugin(p, pluginDatas));
+          }
+        }
+      }
+      return pluginsNeededIds;
     }
 
@@ -273,4 +327,6 @@
         jobData = hiveJob.GetAsJobData(false);
       }
+
+      hiveJob.Job.PluginsNeededIds = this.PluginsNeededIds;
 
       this.progress.Status = string.Format("Uploading job {0} of {1} ({2} kb)", jobCount, totalJobCount, jobData.Data.Count() / 1024);
@@ -618,4 +674,5 @@
       }
     }
+    
   }
 }
